{ pkgs, typeshare }:
let
  standardOverride = attrs: {
      nativeBuildInputs = [
        pkgs.pkg-config
        pkgs.gtk4
      ];
      buildInputs = [
        typeshare
      ];
      verbose = true;
  };
  customBuildInfo = pkgs: pkgs.buildRustCrate.override {
    defaultCrateOverrides = pkgs.defaultCrateOverrides // {
      cairo-sys-rs = standardOverride;
      graphene-sys = standardOverride;
      gobject-sys = standardOverride;
      pango-sys = standardOverride;
      gio-sys = standardOverride;
      gdk-pixbuf-sys = standardOverride;
      gdk4-sys = standardOverride;
      gsk4-sys = standardOverride;
      gtk4-sys = standardOverride;
      kifu-gtk = attrs: {
        nativeBuildInputs = [
          pkgs.glib
          typeshare
        ];
      };
    };
  };
in (import ./Cargo.nix {
  inherit pkgs;
  buildRustCrateForPkgs = customBuildInfo;
  release = true;
}).rootCrate.build
