// import init, { CoreApp } from "kifu-wasm";

const inputField = document.getElementById("input-temp") as HTMLInputElement;
const fromUnitField = document.getElementById("input-unit") as HTMLInputElement;
const toUnitField = document.getElementById("output-unit") as HTMLInputElement;
const outputField = document.getElementById("output-temp") as HTMLInputElement;
const form = document.getElementById("converter") as HTMLFormElement;

function convertTemp(value: number, fromUnit: string, toUnit: string) {
  if (fromUnit === "c") {
    if (toUnit === "f") {
      return (value * 9) / 5 + 32;
    } else if (toUnit === "k") {
      return value + 273.15;
    }
    return value;
  }
  if (fromUnit === "f") {
    if (toUnit === "c") {
      return ((value - 32) * 5) / 9;
    } else if (toUnit === "k") {
      return ((value + 459.67) * 5) / 9;
    }
    return value;
  }
  if (fromUnit === "k") {
    if (toUnit === "c") {
      return value - 273.15;
    } else if (toUnit === "f") {
      return (value * 9) / 5 - 459.67;
    }
    return value;
  }
  throw new Error("Invalid unit");
}

form?.addEventListener("input", () => {
  const inputTemp = parseFloat(inputField.value);
  const fromUnit = fromUnitField.value;
  const toUnit = toUnitField.value;

  const outputTemp = convertTemp(inputTemp, fromUnit, toUnit);
  outputField.value =
    Math.round(outputTemp * 100) / 100 + " " + toUnit.toUpperCase();
});

/*
init().then(async () => {
  let app = new CoreApp();
  console.log("app: ", app, CoreApp);
  await app.dispatch({ type: "PlayingField" });
  console.log("kifu_wasm successfully initted");
});
*/
